Imports System.ComponentModel
Imports System.Text
Imports System.Drawing
Imports System.Windows.Forms.Design

Namespace System.Windows.Forms

   ''' <summary>
   ''' kann zur Designzeit Meldungen ausgeben (hnlich Direktfenster).
   ''' Ist zur Laufzeit auch ganz hbsch
   ''' </summary>
   <Designer(GetType(DesignDebugDesigner))> _
   <System.ComponentModel.DesignerCategory("Code")> _
   Public Class DesignDebugger : Inherits Control

      Private Shared Event MsgEvent As EventHandler
      Public Shared ButtonSize As New Size(100, 20)
      Private Shared ReadOnly _Texts As New StringList

      Private ReadOnly _StringFormat As StringFormat
      Private _LayoutRect As Rectangle
      Private Shared _MsgID As Integer = 0

      Protected Overrides Sub OnMouseClick(ByVal e As MouseEventArgs)
         MyBase.OnMouseClick(e)
         If _Texts.Count = 0 Then Return
         Clipboard.SetText(_Texts.ToString)
         _Texts.Clear()
         Me.Invalidate()
      End Sub

      Public Sub New()
         Me.BackColor = System.Drawing.SystemColors.Window
         ''Me.Width = 500
         Me.Dock = DockStyle.Left
         MyBase.TabStop = False
         _StringFormat = New StringFormat
         _StringFormat.LineAlignment = StringAlignment.Far
         AddHandler MsgEvent, AddressOf DesignDebugger_MsgEvent
      End Sub

      Public Sub DesignDebugger_MsgEvent(ByVal sender As Object, ByVal e As EventArgs)
         Me.Invalidate()
      End Sub

      ''' <summary>_LayoutRect neu festlegen</summary>
      Protected Overrides Sub OnResize(ByVal eventargs As System.EventArgs)
         MyBase.OnResize(eventargs)
         With Me
            _LayoutRect = .ClientRectangle
            _LayoutRect.Height = Short.MaxValue
            _LayoutRect.Y = -(Short.MaxValue - .ClientRectangle.Height)
         End With
         Invalidate()
      End Sub

      Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
         MyBase.OnPaint(e)
         e.Graphics.DrawString( _
            _Texts.ToString(), Me.Font, Brushes.Black, _LayoutRect, _StringFormat)
         ButtonRenderer.DrawButton(e.Graphics, ButtonSize.AlignIn(ClientRectangle, ContentAlignment.TopRight), "move to clipboard", Font, False, VisualStyles.PushButtonState.Default)
      End Sub

      ''' <summary>Meldung ausgeben</summary>
      ''' <param name="Args">Argumentenliste beliebiger Objekte</param>
      Public Shared Sub Msg(ByVal ParamArray Args() As Object)
         Dim toMutch = _Texts.Count - 300
         If toMutch > 0 Then _Texts.RemoveRange(0, toMutch)
         _Texts.Add(_MsgID).AddLine(Args)
         RaiseEvent MsgEvent(Nothing, EventArgs.Empty)
         _MsgID = (_MsgID + 1) Mod 10
      End Sub

      <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
      <Browsable(False)> _
      Public Shadows ReadOnly Property TabStop() As Boolean
         Get
            Return False
         End Get
      End Property

   End Class 'DesignDebugger

   Public Module modDesignDebug
      Public Sub MsgDsn(ByVal sMsg As String)
         DesignDebugger.Msg(sMsg)
      End Sub
      Public Sub MsgDsn(ByVal Arg1 As String, ByVal Arg2 As String)
         DesignDebugger.Msg(New String() {Arg1, Arg2})
      End Sub
      Public Sub MsgDsn(ByVal ParamArray Args() As Object)
         DesignDebugger.Msg(Args)
      End Sub
   End Module

End Namespace

Namespace System.Windows.Forms.Design

   Public Class DesignDebugDesigner : Inherits ControlDesigner
      Private ClearClickRect As Func(Of Rectangle) = Function() (New Size(30, 20)).AlignIn(Control.ClientRectangle, ContentAlignment.TopRight)

      Protected Overrides Function GetHitTest(ByVal point As System.Drawing.Point) As Boolean
         Dim rct = DesignDebugger.ButtonSize.AlignIn(Control.ClientRectangle, ContentAlignment.TopRight)
         Return Control.RectangleToScreen(rct).Contains(point)
      End Function

   End Class

End Namespace
