﻿Imports System.Runtime.CompilerServices
Namespace System.Collections
   Public Module CollectionAttach
      Private Class Attached : Inherits WeakAttachBase(Of IList, Attached)
         Friend Position As Integer
         Public Cyclic As Boolean
         Public Function GetPosition() As Integer
            If Cyclic AndAlso _Key.Count > 0 Then CoercePosition()
            Return Position
         End Function
         Public Function Move(ByVal n As Integer) As Boolean
            Position += n
            If Cyclic Then
               If _Key.Count = 0 Then Return False
               CoercePosition()
               Return True
            End If
            Return Position >= 0 AndAlso Position < _Key.Count
         End Function
         Private Sub CoercePosition()
            Position = Position Mod _Key.Count
            If Position < 0 Then Position += _Key.Count
         End Sub
      End Class
      <Extension()> _
      Public Function Cyclic(Of T As IList)(ByVal subj As T, ByVal value As Boolean) As T
         Attached.GetAttached(subj).Cyclic = value
         Return subj
      End Function
      <Extension()> _
      Public Function Cyclic(ByVal subj As IList) As Boolean
         Return Attached.GetAttached(subj).Cyclic
      End Function
      <Extension()> _
      Public Function Position(Of T As IList)(ByVal subj As T, ByVal value As Integer) As T
         Attached.GetAttached(subj).Position = value
         Return subj
      End Function
      <Extension()> _
      Public Function Position(ByVal subj As IList) As Integer
         Return Attached.GetAttached(subj).GetPosition
      End Function
      <Extension()> _
      Public Function Move(ByVal subj As IList, ByVal [step] As Integer) As Boolean
         Return Attached.GetAttached(subj).Move([step])
      End Function
      <Extension()> _
      Public Function Yield(Of T)(ByVal subj As IList(Of T)) As T
         With Attached.GetAttached(subj)
            Yield = subj(.GetPosition)
            .Position += 1
         End With
      End Function
      <Extension()> _
      Public Function Current(Of T)(ByVal subj As IList(Of T)) As T
         Return subj(Attached.GetAttached(subj).GetPosition)
      End Function
   End Module
End Namespace
