﻿Imports System.Linq
Imports System.Windows.Forms
Imports System.ComponentModel
Imports System.Data
Imports System.Collections.Generic
Imports System.Data.Common

Namespace System.Windows.Forms

   <Diagnostics.DebuggerDisplay("DebugInf={DebugInf}")> _
   Public Class BindingSourceInfo

      Public Table As DataTable
      Public BindingSource As BindingSource
      Private _PlugInfo As New [Set](Of Object, String)

      Public ReadOnly Property DebugInf() As String
         Get
            Return "Count: ".And(Count, ", BindID: ", BindingSource.BindID)
         End Get
      End Property

      Public Overloads Sub Add(ByVal bs As BindingSource)
         Me.Add(New BindingSourceInfo With {.BindingSource = bs, .Table = bs.DataTable})
      End Sub

      Private Function GetIndex(ByVal bs As BindingSource) As Integer
         For i = 0 To Count - 1
            If Me(i).BindingSource Is bs Then Return i
         Next
         Return -1
      End Function


      Public Property Plug() As Boolean
         Get
            Return Not TypeOf BindingSource.DataSource Is Type
         End Get
         Set(ByVal value As Boolean)
            If value = Plug Then Return
            With _PlugInfo
               If .A Is Nothing Then
                  If Not Plug Then
                     Throw Me.Exception("kann PlugInfo nicht initialisieren, da ich unplugged bin")
                  End If
                  .A = BindingSource.DataSource
                  .B = BindingSource.DataMember
               End If
               If value Then
                  BindingSource.ChangeBinding(.A, .B)
               Else
                  Dbg("plug off ", Table.DataSet.GetType.Name, ",", Table.TableName)
                  BindingSource.ChangeBinding(Table.DataSet.GetType, Table.TableName)
               End If
            End With
         End Set
      End Property

   End Class


End Namespace
