﻿Namespace System

   Public Class Extremum(Of T As IComparable)
      Private _MinVal As T
      Private _MaxVal As T
      Private _IsNew As Boolean
      Public Sub New(ByVal ParamArray Values() As T)
         Reset(Values)
      End Sub
      Public Function Reset(ByVal ParamArray Values() As T) As Extremum(Of T)
         _IsNew = True
         Return CheckNew(Values)
      End Function
      Public Function CheckNew(ByVal ParamArray Values() As T) As Extremum(Of T)
         For Each Val As T In Values
            If _IsNew Then
               _MinVal = Val
               _MaxVal = Val
               _IsNew = False
            ElseIf Val.CompareTo(_MinVal) < 0 Then
               _MinVal = Val
            ElseIf Val.CompareTo(_MaxVal) > 0 Then
               _MaxVal = Val
            End If
         Next
         Return Me
      End Function
      Public ReadOnly Property HasValue() As Boolean
         Get
            Return Not _IsNew
         End Get
      End Property
      Public ReadOnly Property MinVal() As T
         Get
            If _IsNew Then
               Throw New ArgumentOutOfRangeException("_MinVal", "didn't check any value")
            End If
            Return _MinVal
         End Get
      End Property
      Public ReadOnly Property MaxVal() As T
         Get
            If _IsNew Then
               Throw New ArgumentOutOfRangeException("_MaxVal", "didn't check any value")
            End If
            Return _MaxVal
         End Get
      End Property
   End Class 'Extremum(Of T As IComparable)

End Namespace